<?php
    /*
    * Module FDMapFP pour Joomla! 3.x
    * Version J3.2P
    * Creation date: Février 2015
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

defined('JPATH_PLATFORM') or die;

class JFormFieldFilesComments extends JFormField
{
	protected $type = 'FilesComments';


	protected function getInput()
	{
		if ($this->form instanceof JForm)
		{
			$params = $this->form->getValue('params');
			$folder = @$params->folder;
			if (!$folder) {
				echo JText::_('MOD_GALLERYFP_SAVE_BEFORE');
				return;
			}
			$param_json = json_decode($this->value);
			if (empty($folder)) return;
			$pic = "../images/".$folder."/";
			$doc = JFactory::getDocument();

			$script = "
			var file;
			var lang;
			var value;
			function FP_change_text(el) 
			{
				file = el.getAttribute('file');
				lang = el.getAttribute('lang');
				value = el.value.replace(/\\\"/g,'\\\\\"');
				eval('FPGallery_photo.'+file+'.'+lang+' = \"'+value+'\"');
				document.getElementById('".$this->id."').value = JSON.stringify(FPGallery_photo);
			}
			";
			$doc->addScriptDeclaration($script);
			
			$dirFiles = array();
			// opens images folder
			if ($handle = opendir($pic)) {
				while (false !== ($file = readdir($handle))) {
					// strips files extensions      
					$crap   = array(".jpg", ".jpeg", ".JPG", ".JPEG", ".png", ".PNG", ".gif", ".GIF", ".bmp", ".BMP", "_", "-");    
				   // hides folders, writes out ul of images and thumbnails from two folders
					if ($file != "." && $file != ".." && $file != "index.php" && $file != "index.html" && $file != "thumbs" && $file != "Thumbnails") {
							$dirFiles[] = $file;
					}
				}
				closedir($handle);
			}
			sort($dirFiles);

			jimport('joomla.language.helper');
			$langues = JLanguageHelper::createLanguageList('', constant('JPATH_SITE'), true, true);
			
			//construction du json
			$json = "\n".' <script type="text/javascript">'."\n".'var FPGallery_photo = {'."\n";
			$json_files = array();
			foreach($dirFiles as $file) {
				$json_file = '"json'.str_replace(array('.', '-', ' '), array('ùùù', 'ààà', 'ééé'), $file).'": {'."\n";
				$json_name = 'json'.str_replace(array('.', '-', ' '), array('ùùù', 'ààà', 'ééé'), $file);
				$json_langage = array();
				foreach ($langues as $langue) {
					$json_lang = str_replace('-', '_', $langue['value']);
					eval('$json_value = @$param_json->'.$json_name.'->'.$json_lang.';');
					$json_langage[] = '"'.str_replace('-', '_', $langue['value']).'":'.'"'.$json_value.'"';
				}
				$json_file .= implode(','."\n", $json_langage);
				$json_file .= '}';
				$json_files[] = $json_file;
			}
			$json .= implode(','."\n", $json_files);
			$json .= '};'."\n".'</script>'."\n";
			// $doc->addScriptDeclaration($json);
			echo $json;

			$compt = 0;
			foreach($dirFiles as $file)
			{
				echo '<div class="control-group ">';
					$filename = substr($file, 0, strrpos($file, '.'));
					echo '<div class="control-label"><label id="jform_params_module_tag-lbl" for="jform_params_module_tag" style="width:250px;" class="hasTooltip" title="" data-original-title="<strong>'.JText::_($this->element['label']).'</strong><br />'.JText::_($this->element['description']).'">
		'.$file.' </label><img src="'.JURI::base().$pic.$file.'" style="height:60px"  /></div>';
					echo '<div class="controls">';
					$json_name = 'json'.str_replace(array('.', '-', ' '), array('ùùù', 'ààà', 'ééé'), $file);
					foreach ($langues as $langue) {
						$json_lang = str_replace('-', '_', $langue['value']);
						eval('$json_value = @$param_json->'.$json_name.'->'.$json_lang.';');
						echo $langue['value'].' <textarea name="'.$file.'_'.$langue['value'].'" file="'.$json_name.'" lang="'.$json_lang.'" id="'.$file.'_'.$langue['value'].'" onChange="FP_change_text(this)">'.$json_value.'</textarea>';
					}
					echo "<br/>\n";
					echo '</div>';
				echo '</div>';
				$compt++;
			}

			echo '<textarea style="display:none;" name="'.$this->name.'" id="' . $this->id . '"" >'.$this->value.'</textarea>';
			
		}
		else return;
	}
	public function getLabel() {
		 return '';
	}
}